kind: Model
api_version: v1beta1
metadata:
  display_name: KG Updater
  name: kg-state-updater
  publisher: CMCL Innovations
  summary: This is used by the CReDo digital twin to read the outputs from the individual asset failure and system-wide impact models, and update the states of the assets at each time step.
  description: >
    This model is used within the CReDo timestep loop workflows. It should be executed after running that individual asset failure and system-wide impact models to update the knowledge graph with the state changes calculated by those models.
spec:
  inputs:
    parameters:
      - name: BLAZEGRAPH_HOST
        title: BLAZEGRAPH_HOST
        default: "blazegraph"
        description: "Host to use when contacting the blazegraph server."
        type: link
        required: true
      - name: BLAZEGRAPH_PORT
        title: BLAZEGRAPH_PORT
        default: 8080
        description: "Port to use when contacting the blazegraph server."
        type: integer
        required: false
      - name: NEW_VALUES_DIR
        title: NEW_VALUES_DIR
        default: ""
        description: "Directory containing the state changes to be applied to the knowledge graph, accepted file extensions are json and csv."
        type: string
        required: false
      - name: ONTOP_HOST
        title: ONTOP_HOST
        default: "ontop"
        description: "Host url to use when contacting the ontop server."
        type: link
        required: true
      - name: ONTOP_PORT
        title: ONTOP_PORT
        default: 8080
        description: "Port to use when contacting the ontop server."
        type: integer
        required: false
      - name: POSTGRES_HOST
        title: POSTGRES_HOST
        default: "postgis"
        description: "Host url to use when contacting the postgres server."
        type: link
        required: true
      - name: POSTGRES_PASSWORD
        title: POSTGRES_PASSWORD
        default: "postpass"
        description: "Password to use when contacting the postgres server."
        type: string
        required: true
      - name: POSTGRES_PORT
        title: POSTGRES_PORT
        default: 5432
        description: "Port to use when contacting the postgres server."
        type: integer
        required: false
      - name: POSTGRES_USER
        title: POSTGRES_USER
        default: "postgres"
        description: "Username to use when contacting the postgres server."
        type: string
        required: false
      - name: SIMULATION_TIMES
        title: SIMULATION_TIMES
        default: ""
        description: "A list of simulation timesteps. Only required when using this model in 'timestep-initialiser' mode."
        type: string
        required: false
      - name: UPDATE_DERIVATIONS
        title: UPDATE_DERIVATIONS
        default: "false"
        description: "Trigger update derivations if set to true"
        type: string
        required: false
